//	TNetworkEndpointDescriptor.h - Macintosh OpenTransport network Endpoint Descriptor class object
// 
// Apple Macintosh Developer Technical Support
// Written by:  Vinne Moscaritolo
//
//  Copyright (work in progress)  Apple Computer, Inc All rights reserved.
//
// You may incorporate this sample code into your applications without
// restriction, though the sample code has been provided "AS IS" and the
// responsibility for its operation is 100% yours.  However, what you are
// not permitted to do is to redistribute the source as "DSC Sample Code"
// after having made changes. If you're going to re-distribute the source,
// we require that you make it clear in the source that the code was
// descended from Apple Sample Code, but that you've made changes.
// 

#ifndef _H_TNetworkEndpointDescriptor
#define _H_TNetworkEndpointDescriptor

#include <OpenTransport.h>
#include "Taddr.h"


//
// TNetworkEndpointDescriptor  - OpenTransport network Endpoint Descriptor class 
//
class TNetworkEndpointDescriptor 
{

public:

// 	CONSTRUCTORS AND DESTRUCTORS
			TNetworkEndpointDescriptor():
								fState(S_UNINIT),
								fConfig(kOTInvalidConfigurationPtr),
								fAddress(NULL) {};
																
			~TNetworkEndpointDescriptor();

// HIGH LEVEL FUNCTIONS
public:
	void* 		Stream();
	void		Unstream(void* in);
	
	OTResult	Validate();
	
	Boolean 	Filter(TCall*);
	Boolean		ValidateBind(TBind*,TBind*);
		

// ACCESSORS
	OTConfiguration*	GetConfiguration() const;
	TAddr*				GetLocalAddress();
	char*				GetServiceName()  { return fServiceName; };
	

// PRIVATE FIELDS
private:
 enum EState { S_UNINIT, S_INIT } ;
	EState				fState;
	OTConfiguration*	fConfig;	
	TAddr*				fAddress;		
	char				fServiceName[255];

};


#endif
