//	TNetworkEvent.h - Macintosh OpenTransport network class object
// 
// Apple Macintosh Developer Technical Support
// Written by:  Vinne Moscaritolo
//
//  Copyright (work in progress)  Apple Computer, Inc All rights reserved.
//
// You may incorporate this sample code into your applications without
// restriction, though the sample code has been provided "AS IS" and the
// responsibility for its operation is 100% yours.  However, what you are
// not permitted to do is to redistribute the source as "DSC Sample Code"
// after having made changes. If you're going to re-distribute the source,
// we require that you make it clear in the source that the code was
// descended from Apple Sample Code, but that you've made changes.
// 

#ifndef _H_TNETWORKEVENT
#define _H_TNETWORKEVENT

#include <OSUtils.h>
#include <OpenTransport.h>
#include "TList.h"
#include "TCachedStorage.h"

//
// TNetworkEvent  - OpenTransport Network Event Base class 
//
class TNetworkEvent  : public TLink, TCachedStorage<TNetworkEvent>
{

public:
// 	CONSTRUCTORS 
	TNetworkEvent (OTEventCode theEvent,  OTResult theResult, void* theParam):
					fEvent (theEvent),
					fResult(theResult),
					fParam (theParam)
						{ ::OTGetTimeStamp(&fTime); };
// PRIVATE FIELDS
public:
	const OTEventCode	fEvent;
	const OTResult		fResult;
	const void* 			fParam;
				OTTimeStamp	fTime;
	

};


#endif
